// Shared library of methods/data for entire extension.
raismth.LIB = {
  
    // APIs
    getCurrentURI: function() {
        return window.location.href;
    },
    getURL: function() {
	return window.content.document.location.href;			   
    },
    getCurrentDoc: function() {
	return window.content.document;
    },
    myDump: function(str) {
	if(raismth && raismth.debug||!raismth) dump(str);
    },
    stDump: function(str, indice) {
	if(raismth) {
		let log = document.createTextNode(str);
		let active = false;
		let obj = window.content.document;
		if(indice >= 0 && raismth.rai_windows[indice]) {
			obj = raismth.rai_windows[indice];
		} 
		active = obj.getElementById('player_status');
		if(active) {
			let log = document.createTextNode(str);
			active.removeChild(active.childNodes[0]);
			active.appendChild(log);
		}
	}
    },		    
    myWrapper: function(doc) {
	return doc.defaultView.wrappedJSObject;
    },

    // Extension app singleton shortcut
    theApp: raismth,
	
    // XPCOM
    Cc: Components.classes,
    Ci: Components.interfaces,
    Cu: Components.utils,
};
