raismth.ns(function() { with (raismth.LIB) {
myDump("[RAISMTH] parsers module initialization\n");
theApp.parsers = {
	parsemData : function(mData, indice) {		
		let url = null;
		let action = null;
		let ttauth = null;
		dump('[RAISMTH] MDATA PARSER =>\n' + mData + '<=\n');
		let lData = mData.toLowerCase();
		if(lData.indexOf('error') != -1 || lData.indexOf('video_no') != -1 || lData.indexOf('raitv.mp4') != -1) {
			ttauth = true;
			action = 1;
			if(!raismth.ntpbypass) {
				let myrnd = raismth.auth.rand(100000, 999999);
				url = "http://videowall.rai.it/cgi-bin/date?" + myrnd;				
				dump('[RAISMTH] Fetching data from Rai NTP Server [' + url + ']\n');
			} else {
				raismth.parsers.bypassNTP(indice);
				dump('[RAISMTH] Bypassing Rai NTP Server\n');
			}
		} else {
			let pattern_1 = 0;
			let pattern_2 = 0;
			ttauth = false;
			if(lData.indexOf('mms') != -1 || lData.indexOf('wmv') != -1 || lData.indexOf('reflector') != -1) {
				pattern_1 = lData.indexOf('href="') + 6;
				pattern_2 = lData.indexOf('"', pattern_1);
				// url = mData.substring(pattern_1, pattern_2);
				action = 5; // play
			} else if (lData.indexOf('mp4') != -1) {
				pattern_1 = lData.indexOf('http');
				pattern_2 = lData.length;
				action = 5;
			} else {
				pattern_1 = lData.indexOf('http');
				pattern_2 = lData.indexOf('"', pattern_1);
				action = 2; // manifest
			}
			url = mData.substring(pattern_1, pattern_2);
		}
		raismth.main.main_loop(url, ttauth, action, indice);
	},

	bypassNTP : function(indice) {
		let year = (new Date()).getFullYear();
		let day = raismth.utils.padString((new Date()).getDate());
		let month = raismth.utils.padString((new Date()).getMonth());
		let hour = raismth.utils.padString((new Date()).getHours());
		let min = raismth.utils.padString((new Date()).getMinutes());
		let sec = raismth.utils.padString((new Date()).getSeconds());
                let rnd1 = raismth.auth.rand(0, 1234);
                let rnd2 = raismth.auth.rand(0, 1234);
		let tokenstring = year + ';' + raismth.lastid + ';' + day + '-' + month + '-' + rnd1 + '-' + hour + '-' + min + '-' + sec + '-' + rnd2;
		let ttauth = raismth.auth.encode3(raismth.auth.encode2(raismth.auth.encode1(tokenstring), 'hMrxuE2T8V0WRW0VmHaKMoFwy1XRc+hK7eBX2tTLVTw='));
		raismth.main.main_loop(null, ttauth, 0, indice);
	},

	parseNTPData : function(mData, indice) {
		let data = mData;
		let day = data.substr(0, 2);
		let month = data.substr(3, 2);
		let year = data.substr(6, 4);
		let hour = data.substr(11, 2);
		let min = data.substr(14, 2);
		let sec = data.substr(17, 2);
		let rnd1 = raismth.auth.rand(0, 1234);
		let rnd2 = raismth.auth.rand(0, 1234);
		let tokenstring = year + ';' + raismth.lastid + ';' + day + '-' + month + '-' + rnd1 + '-' + hour + '-' + min + '-' + sec + '-' + rnd2;
		let ttauth = raismth.auth.encode3(raismth.auth.encode2(raismth.auth.encode1(tokenstring), 'hMrxuE2T8V0WRW0VmHaKMoFwy1XRc+hK7eBX2tTLVTw='));
		raismth.main.main_loop(null, ttauth, 0, indice);
	},	

	parseManifest : function (mData, id, replay) {
		// check manifest
	 	let parser = new DOMParser();
		let dom = parser.parseFromString(mData, "application/xml");
		if(dom.documentElement.childNodes[0].textContent.indexOf('non well-formed') != -1) { //  || replay) {
			// need to normalize
			// if(replay) alert(replay);
			mData = raismth.parsers.normalize(mData);
			dom = parser.parseFromString(mData, "application/xml");
		}
		raismth.parsers.manifest_parser(dom, id);
	},
	manifest_parser : function (dom, idx) {
		myDump('[RAISMTH] ' + idx + ' <- IDX\n');				  
                let doc = raismth.rai_windows[idx];
                let id = doc.getElementById('raismthWindow').getAttribute('name');
                myDump('[RAISMTH] ' + id + ' <- ID\n');
                let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(id));
		myDump('[RAISMTH] ' + indice + ' <- INDICE\n');
		myDump('[RAISMTH] ' + raismth.rai_windows_ts.toString() + ' raismth.rai_windows_ts\n');
		myDump('[RAISMTH] ' + raismth.rai_windows.toString() + ' raismth.rai_windows\n');

		let isLive = false;
		let parser = new DOMParser();
		let eval_pattern = 'SmoothStreamingMedia';
				
		let media  = dom.evaluate(eval_pattern, dom, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
		if(media.snapshotItem(0).getAttribute('IsLive') && media.snapshotItem(0).getAttribute('IsLive').toLowerCase() == "true") isLive = true;
		if(!isLive) {
			eval_pattern += '/Clip';
		}
	       	raismth.video_templ[indice] = new Array();
		raismth.audio_templ[indice] = new Array();
		raismth.video_ext[indice] = new Array();
		raismth.audio_ext[indice] = new Array();
		raismth.video_encoding[indice] = new Array();
		raismth.audio_encoding[indice] = new Array();
		raismth.video_chunks[indice] = new Array();
		raismth.audio_chunks[indice] = new Array();
		raismth.stream_url[indice] = new Array();
		raismth.stream_index[indice] = new Array();
		let sep = null;
		let s = dom.evaluate(eval_pattern, dom, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
		let x = dom.evaluate(eval_pattern + '/StreamIndex', dom, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

                for(let c = 0; c < s.snapshotLength; c++) {
			raismth.video_encoding[indice][c] = new Array();
			raismth.audio_encoding[indice][c] = new Array();
	                raismth.video_ext[indice][c] = new Array();
	                raismth.audio_ext[indice][c] = new Array();

			raismth.stream_url[indice][c] = new Array();
			raismth.video_chunks[indice][c] = new Array();
			raismth.audio_chunks[indice][c] = new Array();
			let v = 2 * c;
			let a = v + 1;
			raismth.stream_index[indice][v] = new Array();
			raismth.stream_index[indice][a] = new Array();

			// myDump('[RAISMTH] ' + x.snapshotItem(v).getAttribute('Type') + '\n');
			// myDump('[RAISMTH] ' + x.snapshotItem(v).getAttribute('Name') + '\n');
			// myDump('[RAISMTH] ' + x.snapshotItem(v).getAttribute('Url') + '\n');
			raismth.video_templ[indice][c] = x.snapshotItem(v).getAttribute('Url');
			let attributes = x.snapshotItem(v).getElementsByTagName('Attribute');
			let customAttr = '';
			for(let k = 0; k < attributes.length; k++){
				// myDump('[RAISMTH] ' + attributes[k].getAttribute('Name') + ' : ' + attributes[k].getAttribute('Value') + '\n');
				sep = k < attributes.length - 1 ? ',' : '';
				customAttr += attributes[k].getAttribute('Name') + '=' + attributes[k].getAttribute('Value') + sep;
			}
			raismth.video_templ[indice][c] = raismth.video_templ[indice][c].replace(/{CustomAttributes}/i, customAttr);
			myDump('[RAISMTH] ' + raismth.video_templ[indice][c] + '\n');

			// myDump('[RAISMTH] ' + x.snapshotItem(a).getAttribute('Type') + '\n');
			// myDump('[RAISMTH] ' + x.snapshotItem(a).getAttribute('Name') + '\n');
			// myDump('[RAISMTH] ' + x.snapshotItem(a).getAttribute('Url') + '\n');
			raismth.audio_templ[indice][c] = x.snapshotItem(a).getAttribute('Url');
			attributes = x.snapshotItem(a).getElementsByTagName('Attribute');
			customAttr = '';
			for(let k = 0; k < attributes.length; k++){
				// myDump('[RAISMTH] ' + attributes[k].getAttribute('Name') + ' : ' + attributes[k].getAttribute('Value') + '\n');
				sep = k < attributes.length - 1 ? ',' : '';
				let att = (attributes[k].getAttribute('Name') != null) ? attributes[k].getAttribute('Name') : attributes[k].getAttribute('Type');
				customAttr += att + '=' + attributes[k].getAttribute('Value') + sep;
			}
			raismth.audio_templ[indice][c] = raismth.audio_templ[indice][c].replace(/{CustomAttributes}/i, customAttr);
			myDump('[RAISMTH] ' + raismth.audio_templ[indice][c] + '\n');

                        let v_chunks = x.snapshotItem(v).getElementsByTagName('c');
                        let a_chunks = x.snapshotItem(a).getElementsByTagName('c');
			let vql = x.snapshotItem(v).getElementsByTagName('QualityLevel');
			let aql = x.snapshotItem(a).getElementsByTagName('QualityLevel');

			if(isLive) {
			} else {
				raismth.stream_url[indice][c] = s.snapshotItem(c).getAttribute('Url');
			}
			myDump('[RAISMTH] ' + raismth.stream_url[indice][c] + ' : ' + c + '\n');


                        for(let i = 0; i < v_chunks.length; i++) {
				raismth.video_chunks[indice][c][i] = v_chunks[i].getAttribute('t');
				if(a_chunks[i]) raismth.audio_chunks[indice][c][i] = a_chunks[i].getAttribute('t');
			}

			for (let p = 0; p < vql.length; p++) {
				raismth.stream_index[indice][v][p] = new Array();
				for(let att = 0; att < vql[p].attributes.length; att++) {
					raismth.stream_index[indice][v][p][att] = vql[p].attributes[att].value;
					raismth.video_encoding[indice][c] = 'wvc1';
					raismth.audio_encoding[indice][c] = 'wave';
			                raismth.video_ext[indice][c] = '.vc1';
					raismth.audio_ext[indice][c] = '.wav';
					if(raismth.stream_index[indice][v][p][3] && raismth.stream_index[indice][v][p][3].toLowerCase() === 'avc1') {
						raismth.video_encoding[indice][c] = 'avc1';
						// mandriva fix
						raismth.video_ext[indice][c] = '.264';
						// raismth.video_ext[indice][c] = '.avc';
					}
					if(raismth.stream_index[indice][v][p][3] && raismth.stream_index[indice][v][p][3].toLowerCase() === 'h264') {
						raismth.video_encoding[indice][c] = 'avc1';
						raismth.video_ext[indice][c] = '.264';
					}
				}
				myDump('[RAISMTH] ' + raismth.stream_index[indice][v][p].toString() + ' : ' + v + '\n');
			}
			for(let p = 0; p < aql.length; p++) {
				raismth.stream_index[indice][a][p] = new Array();
				for(let att = 0; att < aql[p].attributes.length; att++) {
					raismth.stream_index[indice][a][p][att] = aql[p].attributes[att].value;
					// myDump('[RAISMTH] ' + raismth.stream_index[indice][a][p][att] + ' << ' + a + '\n');			
					if(raismth.stream_index[indice][a][p][3] && raismth.stream_index[indice][a][p][3].toLowerCase() === 'aacl') {
        	                                        raismth.audio_encoding[indice][c] = 'aacl';
	                                                raismth.audio_ext[indice][c] = '.aac';
	                                }
				}
				myDump('[RAISMTH] ' + raismth.stream_index[indice][a][p].toString() + ' << ' + a + '\n');
			}
		}
		raismth.parsers.switch_action(doc, indice, isLive);
	},	  			  

	switch_action : function(doc, indice, isLive) {
		raismth.rai.injectRai(doc);
		raismth.rai.injectSMTH(doc, indice);
		raismth.sem = false;
	},	

		/*
		 * Replay template
		 * SmoothStreamingMedia (MajorVersion,MinorVersion,Duration)
		 * SmoothStreamingMedia/Clip (Url,ClipBegin,ClipEnd)
		 * SmoothStreamingMedia/Clip/StreamIndex (Type,SubTypes,Chunks,TimeScale,Url)
		 * SmoothStreamingMedia/Clip/StreamIndex (Type,Name,SubTypes,Chunks,TimeScale,Url)
		 * SmoothStreamingMedia/Clip/StreamIndex/QualityLevel (Index,Bitrate,CodecPrivateData,FourCC,MaxWidth,MaxHeight)
		 * SmoothStreamingMedia/Clip/StreamIndex/QualityLevel (Index,Bitrate,CodecPrivateData,FourCC,AudioTag,Channels,SamplingRate,BitsPerSample,Packetsize)
		 * SmoothStreamingMedia/Clip/StreamIndex/QualityLevel/CustomAttributes
		 * SmoothStreamingMedia/Clip/StreamIndex/QualityLevel/CustomAttributes/Attribute (Name,Value)
		 * SmoothStreamingMedia/Clip/StreamIndex/c (t,d)
		 *
		 * Live template
		 * SmoothStreamingMedia (MajorVersion,MinorVersion,Duration,TimeScale,IsLive,LookAheadFragmentCount,DVRWindowLength)
		 * SmoothStreamingMedia/StreamIndex (Type,SubType,Chunks,TimeScale,Url)
		 * SmoothStreamingMedia/StreamIndex (Type,Name,SubTypes,Chunks,TimeScale,Url) 
		 * SmoothStreamingMedia/StreamIndex/QualityLevel (Index,Bitrate,CodecPrivateData,FourCC,MaxWidth,MaxHeight)
		 * SmoothStreamingMedia/StreamIndex/QualityLevel (Index,Bitrate,CodecPrivateData,FourCC,AudioTag,Channels,SamplingRate,BitsPerSample,Packetsize)
		 * SmoothStreamingMedia/StreamIndex/QualityLevel/CustomAttributes
		 * SmoothStreamingMedia/StreamIndex/QualityLevel/CustomAttributes/Attribute (Name,Value)
		 * SmoothStreamingMedia/StreamIndex/c (t,d)
		 *
		 * 
		 * <StreamIndex Type="audio" Name="track_1" SubType="" Chunks="1795" TimeScale="10000000" Url="QualityLevels({bitrate},{CustomAttributes})/Fragments(track_1={start time})"><QualityLevel Index="0" Bitrate="48000" CodecPrivateData="" FourCC="AACL" AudioTag="255" Channels="2" SamplingRate="48000" BitsPerSample="16" PacketSize="1"><CustomAttributes><Attribute Name="systemLanguage" Value="eng"/></CustomAttributes></QualityLevel><c t="680003653333"/>
		 * let v_url = args[1] + 'QualityLevels(' + vbrate + ')/Fragments(video=' + args[2] + ')';
		 * let a_url = args[1] + 'QualityLevels(' + abrate + ',systemLanguage=eng)/Fragments(track_1=' + args[3] + ')';
		 *
		*/

        normalize : function(s) {
                // myDump('[RAISMTH] s:' + s + '\n');
                var i, f = 0;
                var a = [];
                s += '';
                f = s.length;
                // f = 10;
                var m = 0;
                for(i = 2; i < f; i++) {
                        if(i % 2 == 0) {
                                if(s.charCodeAt(i) != 10 && s.charCodeAt(i) != 13) {
                                        a[m] = s.charCodeAt(i);
                                        a[m] = String.fromCharCode(a[m]);
                                        m++;
                                }
                        }
                }
                var b = a.join('');
                // b = parseInt(b, 16);
                return b;
        },

}

}});
