raismth.ns(function() { with (raismth.LIB) {
myDump("[RAISMTH] rai module initialization\n");

theApp.rai = {
	injectSMTH : function(doc, indice) {		
		let ancora = doc.getElementById('raismthLogo');
		ancora.removeChild(ancora.childNodes[1]);
		let play = null;
		let test = null;
		let span = null;
		let div = null;
		let text = null;
		let testo = null;
		let radio = null;
		let d = 0, e = 0;
		let numclip = raismth.stream_url[indice].length;
		raismth.video_quality[indice] = new Array();
		div = doc.createElement("div");
		div.setAttribute('align', 'left');
		div.setAttribute('style', 'font-weight:bold;font-size:12px;color:white');
		text = raismth.utils.pad('', 5);
		testo = doc.createTextNode(text);
		div.appendChild(testo);
		ancora.appendChild(div);

		div = doc.createElement("div");
		div.setAttribute('align', 'left');
		div.setAttribute('style', 'font-weight:bold;font-size:12px;color:white');
		text = raismth.utils.pad('Smooth Streaming detected, please select clip\'s video quality', 5);
		testo = doc.createTextNode(text);
		div.appendChild(testo);
		ancora.appendChild(div);

		// creazione bottone di play all e combo con i bitrate
		let btnPlayAll = doc.createElement("button");
		btnPlayAll.setAttribute('style', 'font-size:12px');
		btnPlayAll.appendChild(doc.createTextNode("Play all"));
		ancora.appendChild(btnPlayAll);
		btnPlayAll.addEventListener("click", function (event) {
				// recupera il valore di bitrate scelto dalla select e lo mette su tutti i clip della coda
				let ql = parseInt(window.content.document.getElementById('playAll_ql').value);
				for (let i = 0; i < raismth.playQueue[indice].length; i++)
					raismth.playQueue[indice][i].ql = ql;
					
				raismth.playQueueIdx[indice] = 0;
				raismth.main.playNextQueued(indice);
			}, false);
		
		let selBitrate = doc.createElement("select");
		selBitrate.setAttribute("id", "playAll_ql");
		selBitrate.setAttribute('style', 'font-size:12px');
		ancora.appendChild(selBitrate);

		raismth.playQueue[indice] = []
		raismth.playQueueIdx[indice] = -1;
		
		div = doc.createElement("div");
		div.setAttribute('align', 'left');
		div.setAttribute('style', 'font-weight:bold;font-size:12px;color:white');
		text = raismth.utils.pad('', 5);
		testo = doc.createTextNode(text);
		div.appendChild(testo);
		ancora.appendChild(div);
		for(d = 0, e = 0; d < numclip; d++) {
			if(raismth.video_chunks[indice][d].length > 5) {
				e++;
				let clip = '';
				if(numclip > 1) clip = '# ' + e;
				div = doc.createElement("div");
				div.setAttribute('align', 'left');
				div.setAttribute('name', 'replay_' + indice);
				div.setAttribute('id', 'clip_' + d);
				div.setAttribute('title', 'Select video bit rate');
				div.setAttribute('style', 'width:100%; height:40px; margin:5px; font-size:15px; color:white');
				play = doc.createElement('img');
				play.setAttribute('id', 'PLAY_' + d);
				play.setAttribute('src', 'chrome://raismth/skin/videoclip.png');
				play.setAttribute('alt', 'VBR C:' + clip);
				text = raismth.utils.pad(clip + ' [BitRate] ', 0);
				testo = doc.createTextNode(text);
				div.appendChild(play);
				div.appendChild(testo);

				let v = 2 * d;
				let a = v + 1;
				for(let k = 0; k < raismth.stream_index[indice][v].length; k++) {
					let bitrate = parseInt(raismth.stream_index[indice][v][k][1])/1000;
					
					// sul primo clip aggiunge le voci alla select del playall
					if (e == 1)
					{
						let opt = doc.createElement("option");
						opt.value = k
						opt.appendChild(doc.createTextNode(bitrate + "k"));
						selBitrate.appendChild(opt);
					}
					
					text = ' | ' + raismth.utils.pad(bitrate, 0) + 'k';
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					radio = doc.createElement("input");
					radio.setAttribute('type', 'radio');
					radio.setAttribute('id', 'ql_' + indice);
					radio.setAttribute('name', 'ql_' + d);
					radio.setAttribute('value', k);
					div.appendChild(radio);
					radio.addEventListener("click", function (event) {
							let indice = this.getAttribute('id').replace('ql_', '');

							if(raismth.player_istances[indice] && raismth.player_istances[indice].isRunning) {
								stDump('Window busy', indice);
								if(raismth.sem) raismth.sem = false;
							} else if(raismth.smthsem[indice] == true) {
								stDump('Content loading [' + indice + ']', indice);
							} else { 
								let clip = this.getAttribute('name').replace('ql_', '');
								let ql = this.getAttribute('value');

								raismth.rai.unInjectReplayClipControl(indice);
								raismth.rai.injectReplayClipControl(indice, clip, ql);
								myDump('[RAISMTH] ' + raismth.stream_url[indice].toString() + ' <-clip urls\n');
							}
							}, false);

				}
				// aggiunge in coda l'indice del clip, la qualitÃ  sarÃ  valorizzata dopo
				raismth.playQueue[indice].push( {clip: d, ql: -1} );
				
				ancora.appendChild(div);
	                        div = doc.createElement("div");
				div.setAttribute('align', 'left');
				div.setAttribute('name', indice);
				div.setAttribute('id', 'ctrl_' + d);
				div.setAttribute('style', 'visibility:hidden');
				ancora.appendChild(div);
			}
		}
	},

	unInjectReplayClipControl : function(indice) {
		for(let c = 0; c < raismth.video_chunks[indice].length; c++){
			let ancora = window.content.document.getElementById('start_' + c);
			if(ancora){ 
				let childs = ancora.childNodes.length;
				if(childs >= 0){
					for(let d = childs; d > 0; d--) {
						ancora.removeChild(ancora.childNodes[d-1]);
					}
				}
				ancora.parentNode.removeChild(ancora);
			}
		}
	},

	injectReplayClipControl : function(indice, clip, ql) {
		let ancora = window.content.document.getElementById('ctrl_' + clip);
		if(ancora) {
			let doc = raismth.rai_windows[indice];

			// let play = doc.createElement('input');
			let play = doc.createElement('img');
			play.setAttribute('src', 'chrome://raismth/skin/p.png');
			// play.setAttribute('type', 'button');
			play.setAttribute('id', 'cplay_' + clip);
			// play.setAttribute('value', 'Play');


			// let fwd = doc.createElement('input');
			let fwd = doc.createElement('img');
			fwd.setAttribute('src', 'chrome://raismth/skin/f.png');
			// fwd.setAttribute('type', 'button');
			fwd.setAttribute('id', 'fwd_' + clip);
			fwd.setAttribute('name', 0);
			// fwd.setAttribute('value', 'Fwd');

			// let rew = doc.createElement('input');
			let rew = doc.createElement('img');
			rew.setAttribute('src', 'chrome://raismth/skin/r.png');
			// rew.setAttribute('type', 'button');
			rew.setAttribute('id', 'rew_' + clip);
			// rew.setAttribute('value', 'Rew');
		
			let starter = doc.createElement('div');
			starter.setAttribute('style', 'font-size:20px;visibility:visible');
			starter.setAttribute('id', 'start_' + clip);
			starter.setAttribute('name', ql); 
			starter.setAttribute('align', 'left');

			let filler = doc.createTextNode(raismth.utils.pad('', 10));
			starter.appendChild(filler);
			starter.appendChild(rew);
			starter.appendChild(play);
			starter.appendChild(fwd);
			ancora.appendChild(starter);

			rew.addEventListener("click", function (event) {
					let clip = this.id.replace('rew_', '');
					let ancora = window.content.document.getElementById('ctrl_' + clip);
					let fwd = window.content.document.getElementById('fwd_' + clip);
					let indice = ancora.getAttribute('name');
					let val = parseInt(fwd.getAttribute('name'));
					if(val > 0) {
						val--;
						fwd.setAttribute('name', val);
						let clip_length = raismth.video_chunks[indice][clip].length;
						let vstate = 'Offset: ' + val*2 + ' sec - chunk ' + val + ' of ' + clip_length;
						stDump(vstate, indice);
					}
					}, false);

			rew.addEventListener("dblclick", function (event) {
					let clip = this.id.replace('rew_', '');
					let ancora = window.content.document.getElementById('ctrl_' + clip);
					let fwd = window.content.document.getElementById('fwd_' + clip);
					let indice = ancora.getAttribute('name');
					let val = parseInt(fwd.getAttribute('name'));
					if(val > 10) {
					val = val - 10;
					fwd.setAttribute('name', val);
					let clip_length = raismth.video_chunks[indice][clip].length;
					let vstate = 'Offset: ' + val*2 + ' sec - chunk ' + val + ' of ' + clip_length;
					stDump(vstate, indice);
					}
					}, false);
			
			fwd.addEventListener("click", function (event) {
					let clip = this.id.replace('fwd_', '');
					let ancora = window.content.document.getElementById('ctrl_' + clip);			
					let indice = ancora.getAttribute('name');
					let val = parseInt(this.name);
					if(val < raismth.video_chunks[indice][clip].length - 10) {
						val++;					
						this.name = val;
						let clip_length = raismth.video_chunks[indice][clip].length;	
						let vstate = 'Offset: ' + val*2 + ' sec - chunk ' + val + ' of ' + clip_length;
						stDump(vstate, indice);
					}
					}, false);			

			fwd.addEventListener("dblclick", function (event) {
					let clip = this.id.replace('fwd_', '');
					let ancora = window.content.document.getElementById('ctrl_' + clip);
					let indice = ancora.getAttribute('name');
					let val = parseInt(this.name);
					if(val < raismth.video_chunks[indice][clip].length - 20) {
					val = val + 10;
					this.name = val;
					let clip_length = raismth.video_chunks[indice][clip].length;
					let vstate = 'Offset: ' + val*2 + ' sec - chunk ' + val + ' of ' + clip_length;
					stDump(vstate, indice);
					}
					}, false);

			play.addEventListener("click", function (event) {
					let clip = this.id.replace('cplay_', '');
					let ancora = window.content.document.getElementById('ctrl_' + clip);
					let indice = ancora.getAttribute('name');

					if(raismth.player_istances[indice] && raismth.player_istances[indice].isRunning) {
						stDump('Window busy', indice);
						if(raismth.sem) raismth.sem = false;
					} else if(raismth.smthsem[indice] == true) {
						stDump('Content loading', indice);					
					} else {
						let start = window.content.document.getElementById('fwd_' + clip).getAttribute('name');
						let delay = ((parseInt(raismth.audio_chunks[indice][clip][start]) - parseInt(raismth.video_chunks[indice][clip][start])) / 10000000);
						let skip = 0; 
						if(start > 0) skip = parseInt(delay / 2);
						let v = clip * 2;
						let clip_length = raismth.video_chunks[indice][clip].length;
						let video_chunk = raismth.video_chunks[indice][clip][start];
						let audio_chunk = raismth.audio_chunks[indice][clip][start-skip];
						let url = raismth.stream_url[indice][clip];
						let windowid = raismth.rai_windows_ts[indice];
						let doc = raismth.rai_windows[indice];
						let ql = window.content.document.getElementById('start_' + clip).getAttribute('name');
						raismth.video_quality[indice][clip] = raismth.stream_index[indice][v][ql][0];
						raismth.main.main_loop(url, [video_chunk, audio_chunk, indice, clip, ql], 6, windowid);
					}

					}, false);
			ancora.setAttribute('style', 'visibility:visible');
		}
	},

	injectSilverlightControl : function(doc, container){
		let player = doc.getElementById('silverlightControl') || doc.getElementById('SilverlightControl') || doc.getElementById('silverlightControlHost') || doc.getElementById('SilverlightControlHost');					   
		if( player != null ) {
			let windowid = doc.getElementById('raismthWindow');
			let windowident = null;
			let contents = null;
			if(windowid) windowident = windowid.getAttribute('name');
	                let silverlight = null;
			silverlight = player.children;
			// dump(raismth.silverlight.odump(silverlight) + '\n');
	                if(silverlight === null) {
	                        myDump('[RAISMTH] Unable to fetch silverlight box\n');
	                } else {
	                        myDump('[RAISMTH] Silverlight box fetched\n');
				myWrapper(doc).getServerTime = function() { return 1344809000000; };
	                        let mediaUri = null;
	                        let isSmooth = null;
	                        let myMsg = '';
	                        for(let c = 0; c < silverlight.length; c++){
	                                switch(silverlight[c].name){
	                                        case 'initParams':
	                                                let stringa = silverlight[c].value;
							let stop = stringa.indexOf(',' , stringa.indexOf('mediaUri')+9) != -1 ? stringa.indexOf(',' , stringa.indexOf('mediaUri')+9) : stringa.length;
	                                                mediaUri = stringa.substring(stringa.indexOf('mediaUri')+9, stop);
	                                                break;
	                                }
	                        }
				// alert(myWrapper(doc).$('.realRadio').find('object,embed').length);
				// alert(myWrapper(doc).MediaItem.autoplay);
				// alert(myWrapper(doc).idFruizione);
				
				if(!mediaUri && myWrapper(doc).videoURL) mediaUri = myWrapper(doc).videoURL;
					
				/*
				if(!mediaUri) {
					let scripts = doc.getElementsByTagName('script');
					for(var x = 0; x < scripts.length; x++){
						if(scripts[x].innerHTML.indexOf('videoURL') != -1) {
							alert(myWrapper(doc).videoURL);
							let content = scripts[x].innerHTML;
							let pattern_1 = content.indexOf('videoURL') + 12;
							let pattern_2 = content.indexOf('"', pattern_1);
							mediaUri = content.substring(pattern_1, pattern_2);
							break;                                       
						}
					}
				}
				*/
	                        if(mediaUri != null) {
					if (raismth.nativePlayer||container.getAttribute('class') == "Player") {
						container.innerHTML = '';
						raismth.rai.injectSilverlightPlayer(doc);
					}
					
					let anchor = doc.getElementById('raismthLogo');
					let contenitore = doc.createElement("div");
					contenitore.setAttribute('id', 'raismthControl');
					contenitore.setAttribute('align', 'left');
					contenitore.setAttribute('style', 'font-size:15px'); 

					let id = mediaUri;
					let name = windowident;
					let test = null;
					let span = null;
					let div = null;
					let text = null;
					let testo = null;
					
					
					// empty divs
					let height = 20;
					if(doc.location.href.indexOf('popup') != -1) height = 60;
                                        div = doc.createElement("div");
					div.setAttribute('style', 'height: ' + height + 'px;');
					text = raismth.utils.pad('', 1);
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					contenitore.appendChild(div);
					/*
					div = doc.createElement("div");
					text = raismth.utils.pad('', 1);
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					contenitore.appendChild(div);

					div = doc.createElement("div");
					text = raismth.utils.pad('', 1);
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					contenitore.appendChild(div);
					// 
					*/
					div = doc.createElement("div");
					div.setAttribute('name', 'play_' + name);
					div.setAttribute('id', 'play_' + id);
					div.setAttribute('style', 'cursor:pointer;font-size:30px;color:white');
					div.setAttribute('title', 'Play content');
					let play = doc.createElement('img');
					play.setAttribute('src', 'chrome://raismth/skin/arrow.png'); // play.png
					play.setAttribute('alt', 'Play');
					text = raismth.utils.pad(' Play', 5);
					testo = doc.createTextNode(text);
					div.appendChild(play);
					div.appendChild(testo);
					contenitore.appendChild(div);

					div.addEventListener("click", function (event) {
							if(!raismth.sem) {
								raismth.sem = true;

							        raismth.selection = this.getAttribute('id').replace('play_', '');
								let nome = window.content.document.getElementById('raismthWindow').getAttribute('name');
								let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(nome));

								myDump('[RAISMTH] ID:' + raismth.selection + ' NOME:' + nome + ' indice:' + indice + '\n');
								if(raismth.player_istances[indice]) {
									stDump('Window busy', indice);
									if(raismth.sem) raismth.sem = false;
								} else {
									raismth.chunks[indice] = 0;
									let action = 0;
									if(raismth.selection.indexOf('mms') != -1 || raismth.selection.indexOf('wmv') != -1) action = 5;
									raismth.main.main_loop(raismth.selection, false, action, nome);
								}
							}
							}, false);

					// empty div
					div = doc.createElement("div");
					text = raismth.utils.pad('', 1);
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					contenitore.appendChild(div);
			
					// user defined channels
					// 
					let d = 0;
					for(d = 0; d < 3; d++) {
						div = doc.createElement("div");
						// div.setAttribute('name', 'chan_' + name);
						div.setAttribute('id', 'mychan_' + raismth.chan[d]);
						div.setAttribute('style', 'font-size:24px;color:white');
						play = doc.createElement('img');
						play.setAttribute('id', 'chan_' + raismth.chan[d]);
						play.setAttribute('name', 'chan_' + name);
						play.setAttribute('style', 'cursor:pointer;');
						play.setAttribute('title', 'Play User Defined Channel ' + (d+1));
						play.setAttribute('src', 'chrome://raismth/skin/arrow.png');
						play.setAttribute('alt', 'Play chan ' + (d+1));

						text = raismth.utils.pad(' My Relinker ' + raismth.chan[d], 5);
						testo = doc.createTextNode(text);
		                                
						let opt = doc.createElement('img');
						opt.setAttribute('style', 'cursor:pointer;');
						opt.setAttribute('title', 'Edit User Defined Channel ' + (d+1));
		                                opt.setAttribute('id', 'OPT_' + d);
		                                opt.setAttribute('src', 'chrome://raismth/skin/prop.png');
		                                opt.setAttribute('alt', 'Edit chan ' + (d+1));
						
						div.appendChild(opt);
						div.appendChild(play);
						div.appendChild(testo);
						// div.appendChild(opt);

						contenitore.appendChild(div);

						opt.addEventListener("click", function (event) {
								let indice = parseInt(this.getAttribute('id').replace('OPT_',''));
								let old = raismth.chan[indice];
								let chan = prompt('Please enter new value for channel ' + (indice+1), old);
								if(chan) {									
									chan = parseInt(chan);
									let ref = window.content.document.getElementById('mychan_' + chan);
									if(ref === null) {
										ref = window.content.document.getElementById('mychan_' + old);
										let pl =  window.content.document.getElementById('chan_' + old);
										raismth.chan[indice] = chan;
										raismth.prefs.setIntPref("user-chan" + (indice+1), chan);
										ref.childNodes[2].textContent = ' My Relinker ' + chan;
										ref.id = 'mychan_' + chan;
										pl.id = 'chan_' + chan;
									} 
								}

								}, false);

						play.addEventListener("click", function (event) {
								if(!raismth.sem) {
									let ts = parseInt(window.content.document.getElementById('raismthWindow').getAttribute('name'));
									let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, ts);
									if(raismth.player_istances[indice] && raismth.player_istances[indice].isRunning) {
										stDump('Window busy', indice);
									} else if(raismth.smthsem[indice] == true) {                                                                                                            								stDump('Content loading', indice);
									} else {
										raismth.sem = true;
										raismth.chunks[indice] = 0;
										raismth.selection = this.getAttribute('id').replace('chan_', 'http://mediapolis.rai.it/relinker/relinkerServlet.htm?cont=');
										let nome = this.getAttribute('name').replace('chan_', '');
										raismth.main.main_loop(raismth.selection, false, 0, nome);
									}
								}
								}, false);
					}
					
					// empty div
					div = doc.createElement("div");
					text = raismth.utils.pad('', 1);
					testo = doc.createTextNode(text);
					div.appendChild(testo);
					contenitore.appendChild(div);

					anchor.appendChild(contenitore);
	                        } 
						
	                }
	                // plugins.hide_infobar_for_missing_plugin = true
		} else {
			myDump('[RAISMTH] Silverlight box not loaded\n');
			/*
			let scripts = doc.getElementsByTagName('script');
			for(var x = 0; x < scripts.length; x++){
				if(scripts[x].innerHTML.indexOf('videoURL') != -1) {
					let content = scripts[x].innerHTML;
					let pattern_1 = content.indexOf('videoURL') + 12;
					let pattern_2 = content.indexOf('"', pattern_1);
					let video_url = content.substring(pattern_1, pattern_2);
					break;
				}
			}
			*/
		}	
        },

        injectSilverlightPlayer : function(doc){
		let width = "100%";
		let height = "100%";
		let nocont = false;
		let player = doc.getElementById('SilverlightPlayer') || doc.getElementById('idPlayer') || doc.getElementById('slHost') || doc.getElementById('SilverlightControlHost') || doc.getElementById('silverlightControlHost') || doc.getElementById('Player') || doc.getElementById('player');
		if(!player) {
			player = doc.getElementsByClassName('Player')[0] || doc.getElementsByClassName('player')[0];
			nocont = true;
			width = "536";
			height = "432";
		}
		if(player) {
			player.setAttribute("style", "height: " + height + "; width: " + width + "; background-image: url(chrome://raismth/skin/ss.jpg); background-repeat: no-repeat; background-size: 100%");
			let logo = doc.getElementById('raismthLogo');
	                if(!logo) {
				let contenitore = doc.createElement("div");
				contenitore.setAttribute('id', 'raismthLogo');
                                player.appendChild(contenitore);
			}
		} else {
			player = null;
		}
		return player;
        },	

	getPosition : function(obj) {
		let topValue = 0; // ,leftValue= 0;
    		while(obj){
			// leftValue += obj.offsetLeft;
			topValue += obj.offsetTop;
			obj = obj.offsetParent;
    		}
	    	// let finalvalue = leftValue + "," + topValue;
	    	// return finalvalue;
		return topValue;
	},

	injectRaismthStatus : function(doc, container) {
		let wintop = 375;
		
		if(!doc.location) {
			doc = window.content.document;
			// wintop = 100;
		}		
		/*
		dump(raismth.rai.getPosition(doc.getElementById('raismthControl')) + ' <--position\n');
		dump(raismth.rai.getPosition(doc.getElementById('raismthLogo')) + ' <--position\n');		
		dump(raismth.rai.getPosition(container) + ' <--position\n');
		dump(container.height + ' <--height\n');
		*/
		// if(doc.location.href.toLowerCase().indexOf('replay') != -1) wintop = 520;
		if(doc.location.href.toLowerCase().indexOf('report') != -1) wintop = 630;
		if(doc.location.href.toLowerCase().indexOf('media') != -1 && doc.location.href.toLowerCase().indexOf('tg') != -1 && doc.location.href.toLowerCase().indexOf('videourl') == -1) wintop = 230;
		if(doc.location.href.toLowerCase().indexOf('rubriche') != -1) wintop = 490;
		if(doc.location.href.toLowerCase().indexOf('edizioni') != -1 || doc.location.href.toLowerCase().indexOf('videourl') != -1) wintop = 460;
		if(doc.location.href.toLowerCase().indexOf('tgr') != -1 || doc.location.href.toLowerCase().indexOf('news.html') != -1) wintop = 280;
		if(doc.location.href.toLowerCase().indexOf('tg2.rai.it') != -1) wintop = 200;
		let anchor = doc.getElementById('raismthLogo'); 
		if(anchor) {
			let test = doc.createElement("h1");
			let span = doc.createElement("span");
			span.setAttribute("class", "c");
			span.setAttribute("align", "left");
			test.setAttribute("class", "title");
			let div = doc.createElement("div");
			div.setAttribute('id', 'player_status');
			div.setAttribute("style", "position:absolute;top:" + wintop + "px;font-size:12px;color:white");
			let text = raismth.utils.pad('[RAISMTH - Smooth Streaming Player for Linux - mitm|kowalsky]', 5);
			let testo = doc.createTextNode(text);
			div.appendChild(testo);
			span.appendChild(div);
			test.appendChild(span);
			anchor.appendChild(test);
		}
		raismth.utils.version_check("http://acab.servebeer.com/v.php?v=3.0.3", raismth.utils.showMessage, doc);
	},			      
			      
	injectRai : function(doc) {
		let windowid = doc.getElementById('raismthWindow'); 
		myDump('[RAISMTH] ' + windowid + ' winid\n');
		if(windowid === null) {
			let now = (new Date()).getTime();
	    		let div = doc.createElement("div");
			div.setAttribute('id', 'raismthWindow');
			div.setAttribute('name', now);
			doc.body.appendChild(div);
			let index = raismth.rai_windows.length;
			for(let c = 0; c < raismth.rai_windows.length; c++) {
				if(raismth.rai_windows[c] === null) {
					index = c;
					break;
				} 
			}
			raismth.rai_windows[index] = doc; 
			raismth.rai_windows_ts[index] = now; 
			raismth.rai.injectRaiHref(doc);
			myDump('[RAISMTH] ' + doc.getElementById('raismthWindow').getAttribute('name') + '\n');
		}
	},

	injectRaiHref : function(doc) {
		let windowid = null;
		windowid = doc.getElementById('raismthWindow').getAttribute('name');
		let rai_links = doc.getElementsByTagName('a');
		for(let c = 0; c < rai_links.length; c++){

			if(rai_links[c].getAttribute('href') && rai_links[c].getAttribute('href').indexOf('channel=')) {
				rai_links[c].setAttribute('name', windowid);
				rai_links[c].addEventListener("click", raismth.rai.injectListener, false);
			}
			if(rai_links[c].getAttribute('href') && rai_links[c].getAttribute('href').indexOf('day=') && rai_links[c].getAttribute('href').indexOf('ch=')) {
				rai_links[c].setAttribute('name', windowid);
				rai_links[c].addEventListener("click", raismth.rai.injectListener, false);
			}
			if(rai_links[c].getAttribute('href') && rai_links[c].getAttribute('href').indexOf('#') != -1) {
				rai_links[c].setAttribute('name', windowid);
				rai_links[c].addEventListener("click", raismth.rai.injectListener, false);
			}
		}
	},		

	uninjectRaiHref : function(doc) {
		let rai_links = doc.getElementsByTagName('a');
		for(let c = 0; c < rai_links.length; c++){
			if(rai_links[c].getAttribute('href') && rai_links[c].getAttribute('href').indexOf('day=') && rai_links[c].getAttribute('href').indexOf('ch=')) {
				rai_links[c].removeEventListener("click", raismth.rai.injectListener, false);
			}
		}				
	},	

	injectListener : function(event) {
		let windowid = this.getAttribute('name');
		let indice = raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid));
		let doc = raismth.rai_windows[raismth.utils.arrayIndexOf(raismth.rai_windows_ts, parseInt(windowid))];
		let callback = ((this.getAttribute('href').indexOf('v=') != -1 || this.getAttribute('href').indexOf('channel=') != -1) || this.getAttribute('href').indexOf('#') != -1) ? raismth.rai.injectDelayed : raismth.rai.injectRaiHref;
		let timeout = 1000;
		if(callback == raismth.rai.injectDelayed) timeout = 2000;
		if(doc.location.href.toLowerCase().indexOf('tgr') != -1 || doc.location.href.toLowerCase().indexOf('news.html') != -1) timeout = 3000;
		raismth.myTimer[indice] = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		raismth.myTimer[indice].initWithCallback(function() { callback(doc); } , timeout, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	},		

	injectDelayed : function(doc) {
		if(doc.getElementById('player_status') == null) {
			let container = raismth.rai.injectSilverlightPlayer(doc);
			raismth.rai.injectSilverlightControl(doc, container);
			raismth.rai.injectRaismthStatus(doc);
		}	
	},	
	
	isPlaying : function(url) {
		let success = false;			    
		if(url != null) {			    
			let contents = url;
			if(url.search('=') != -1) {
				contents = url.substring(url.lastIndexOf('=') + 1);
			} else if(url.search('/') != -1) {
				contents = url.substring(url.lastIndexOf('/') + 1);
			} 
			for(let c = 0; c < raismth.player_istances_pid.length; c++) {
				if(raismth.player_istances_pid[c] == url || raismth.player_istances_pid[c] == contents) {
					success = true;
					break;
				}
			}
		}
		return success;
	},
}

}});
